/**
  ******************************************************************************
  * @file    system_PT32x007x.h
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  */


  /* Define to prevent recursive inclusion -------------------------------------*/
#ifndef SYSTEM_PT32x007x_H
#define SYSTEM_PT32x007x_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32x007x.h"

#define RCC_Freq_HSI   64000000UL
#define RCC_Freq_LSI   32768UL





/* Exported macro ------------------------------------------------------------*/
/* Exported functions ---------------------------------------------------------*/
u32 CLOCK_GetSYSCLK(void);
void CLOCK_Cmd(void);	
void CLOCK_PLLConfig(void);     
void CLOCK_SystemClockConfig(void);   
void CLOCK_MCOConfig(void);
void SystemInit(void);
#ifdef __cplusplus
}
#endif

#endif /*system_PT32x007x_h*/

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */


/******************* (C) Ȩ Pai-IC Microelectronics *****END OF FILE****/

