  /******************************************************************************
  * @Example PWM
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ʹPWMģʽ̶50Hz,ϵռձΪ20%
	*					 ûɰUSER_KEYıռձȡʾCH1(PC6)ɹ۲쵽Ρ
  *          
  ******************************************************************************
  * @attention	 
  *  ʹø̣
  *  Ҫ蹩߽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32x007x.h"

#define		KEY_PROT		GPIOC
#define		KEY_PIN	    GPIO_Pin_3

void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

void KEY_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				    //һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = KEY_PIN;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;		//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	  //
	GPIO_Init(KEY_PROT, &GPIO_InitStructure);		//ÿ⺯ʼGPIO
		
  GPIO_SetBits(KEY_PROT, KEY_PIN);					//GPIO״̬
}

/**
* @brief TIM1ĸ
* @param 
* @retval 
*/
void TIM_GPIO_Config(void)
{
  GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_2,ENABLE);//CH1
}

/**
* @brief TIM1ʽ
* @param 
* @retval 
*/
void TIM_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef PWM_TimeBaseInitType;
	PWM_OCInitTypeDef OutInit;
	/* ʱѡ */
	PWM_TimeBaseInitType.PWM_InternalClockSource = PWM_InternalClockSource_SYSCLK;
	/* ģʽ --  */
	PWM_TimeBaseInitType.PWM_CenterAlignedMode = PWM_CenterAlignedMode_Enable;
	/* ģʽΪϼ */
	PWM_TimeBaseInitType.PWM_Direction = PWM_Direction_Up;
	/* ƥĴ,ۼMR0+1Ƶʺһ»ж */
	PWM_TimeBaseInitType.PWM_AutoReloadValue = 10000;
	/* CNTʱ = Fcksys/(psc+1)*/
	PWM_TimeBaseInitType.PWM_Prescaler = 63;
	/* ʼTIM1*/
	PWM_TimeBaseInit(TIM1,&PWM_TimeBaseInitType);
	/* ΪPWMͨΪ1ͨ*/
	OutInit.PWM_Channel =PWM_Channel_1;
	/* ΪPWMģʽ */	
	OutInit.PWM_OCMode = TIM_OCMode_PWM1;
	/* ͻ */
	OutInit.PWM_OCNOutput = PWM_OCNOutput_Disable;		
	OutInit.PWM_OCOutput = PWM_OCOutput_Enable;  
	/* PWMʱƽ״̬ */	
	OutInit.PWM_OCIdleState = PWM_OCIdleState_Low;
	OutInit.PWM_OCNIdleState = PWM_OCNIdleState_Low;
	/* PWMռձ P = (PWM_OCValue+1) / (PWM_AutoReloadValue+1)*/	
	OutInit.PWM_OCValue = 2000-1;
    /* PWMȽ*/	
	OutInit.PWM_OCPolarity = PWM_OCPolarity_High;
    OutInit.PWM_OCNPolarity = PWM_OCNPolarity_High;
	/* ʼPWM */
	PWM_OCInit(TIM1, &OutInit);
	/* ʹPWM */
	PWM_Cmd(TIM1,ENABLE);
}

/**
* @brief PWMռձȺ
* @param duty:ʱװֵ
* @retval 
*/
void Set_Pwm_Duty(u16 duty)
{
	if(duty >= TIM1->ARR)
		duty = (TIM1->ARR -1);
	TIM1->OCR1 = duty;
}

int main()
{
	KEY_Driver();
	/*TIM1*/
	TIM_GPIO_Config();
	TIM_Mode_Config();

	while(1)
	{
		if(GPIO_ReadDataBit(KEY_PROT,KEY_PIN)==0)
		{
			Delay(5000);
			if(GPIO_ReadDataBit(KEY_PROT,KEY_PIN)==0)
			{
				Set_Pwm_Duty(PWM_GetAutoreload(TIM1)-PWM_GetOCxValue(TIM1,PWM_Channel_1));
				while(!GPIO_ReadDataBit(KEY_PROT,KEY_PIN));
			}
		}
	}
}
	
 
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
