/******************************************************************************
  * @Example Tim4WakeUp
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ÿ2ҽһ˯ģʽ,5
  *          
  ******************************************************************************
  * @attention	
  * ͹Ĳʱ
	* ϿJ9(POWER)
  * ñJ8(MCU POWER)
	* (P1)ӴVOUT GND⣬TX RX SWDIO SWCLK NRSTȫϿ
	* TIM4ʱLSIɹرLSI
	* 
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *			
  *****************************************************************************/
	
#include "PT32x007x.h"

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

void Timer4_Mode_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;

	/*ʹTIMER4NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM4_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x03;
	NVIC_Init(&NVIC_InitStruct);
	
	/* CNTʱ = 32khz/(psc+1)*/
	TimeBaseInit.TIM_Prescaler=127;
	TimeBaseInit.TIM_Direction=TIM_Direction_Down;
	TimeBaseInit.TIM_AutoReload=1279;// 5
	
	TIM_TimeBaseInit(TIM4, &TimeBaseInit);
	TIM_ITConfig(TIM4, TIM_CR2_ARI, ENABLE);
	TIM_Cmd(TIM4, ENABLE);
}

void Timer4_Disable(void)
{
	TIM_ITConfig(TIM4, TIM_CR2_ARI, DISABLE);
	NVIC_DisableIRQ(TIM4_IRQn);	
	TIM_Cmd(TIM4, DISABLE);
}

void Tim4_Wake_Sleep(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	Timer4_Mode_Config();
  Software_Delay();
	
	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOD, GPIO_Pin_All, DISABLE);

	GPIO_DigitalRemapConfig(AFIOA, (GPIO_Pin_All),AFIO_AF_None,DISABLE);	//SWDӿڲ
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_All&(~GPIO_Pin_1),AFIO_AF_None,DISABLE);
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_All&(~GPIO_Pin_7),AFIO_AF_None,DISABLE);
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_All&(~GPIO_Pin_1),AFIO_AF_None,DISABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_In;
	GPIO_InitStructure.GPIO_Pull=GPIO_Pull_Down;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	PWR_EnterDeepSleepMode(PWR_DeepSleepEntry_WFI);   //˯ߣʱ

	Timer4_Disable();
  Software_Delay();
}

int main (void)
{
	while(1)
	{
		Software_Delay();
		Software_Delay();
		Tim4_Wake_Sleep();
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


