/******************************************************************************
  * @Example ExitWakeUp
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ϵ˯ߣPC3һ½غ
  *          
  ******************************************************************************
  * @attention	
	* ͹Ĳʱ
	* ϿJ9(POWER)
  * ñJ8(MCU POWER)
	* (P1)ӴVOUT GND⣬TX RX SWDIO SWCLK NRSTȫϿ
	* رLSIĽ
  *	ʱʹߣһPC3һζ̽оƬVDDϿԲһ½ؽл
	*
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32x007x.h"

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<200; x++);
}


void Wake_Key_Init(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;
	GPIO_InitTypeDef GPIO_InitStructure;					//һGPIO_InitTypeDef͵Ľṹ
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;	//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;
	GPIO_Init(GPIOC, &GPIO_InitStructure);			  //ÿ⺯ʼGPIO
	
	//GPIO˿жϴѡ
	EXTI_TriggerTypeConfig(EXTIC,GPIO_Pin_3,EXTI_Trigger_RisingFalling);
	EXTI_ITConfig(EXTIC,GPIO_Pin_3,ENABLE);		//GPIO˿жʹ
	
	/*ʹGPIONVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = EXTIC_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
}

void Key_Wake_Sleep(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_AnalogRemapConfig(AFIOA, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_All, DISABLE);
	GPIO_AnalogRemapConfig(AFIOD, GPIO_Pin_All, DISABLE);
	
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_All,AFIO_AF_None,DISABLE);	//SWDӿڲ
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_All&(~GPIO_Pin_1),AFIO_AF_None,DISABLE);
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_All&(~GPIO_Pin_7),AFIO_AF_None,DISABLE);
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_All&(~GPIO_Pin_1),AFIO_AF_None,DISABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;	
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_In;	
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Down;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All&(~GPIO_Pin_3);	
	GPIO_Init(GPIOC, &GPIO_InitStructure);	
	
	PWR_EnterDeepSleepMode(PWR_DeepSleepEntry_WFI);	//˯ߣжϻ
	
	Software_Delay();
	Software_Delay();
}


int main (void)
{
	Wake_Key_Init();
	Software_Delay();	
	RCC_ClockSourceConfig(RCC_ClockSource_LSI,DISABLE);
	while(1)
	{
		Key_Wake_Sleep();
	}

}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_						param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
