/**
  ******************************************************************************
  * @file    Project/PT32X007x_StdPeriph_Templates/PT32X007x_it.h 
  * @author  Application Team
  * @version V1.0.0
  * @date    2023/4/5
  * @brief   This file contains the headers of the interrupt handlers.
  ******************************************************************************
  * @attention
  *
  * 
  *
  *
  * 
  * 
  *
  *        
  *
  *  
  *  
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __PT32X007x_IT_H
#define __PT32X007x_IT_H

#ifdef __cplusplus
 extern "C" {
#endif 

/* Includes ------------------------------------------------------------------*/
#include "PT32X007x.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

void NMI_Handler(void);
void HardFault_Handler(void);
void SVC_Handler(void);
void PendSV_Handler(void);
void SysTick_Handler(void);

/*void PPP_IRQHandler(void);*/

#ifdef __cplusplus
}
#endif

#endif /* __PT32X007x_IT_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
