/******************************************************************************
  * @Example UART
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ʹUART0UART1Ϻշģкշ
  *          
  ******************************************************************************
  * @attention
  * 1UART0Ϊͨշܣ24001λֹͣλżУ
	*	2UART1Ϊⷢ͹ܣ24001λֹͣλżУ
	* 3ϵUART0ͻӭ䣬ûͨλոϢ
	* 4ûUSER_KEYUART1Ϻⷢģ飬ܷͨãϢɺ߷
	* 5źŷUART0Ϻģ飬ոϢͣûͨλոϢ
	* 6շûٴΰUSER_KEYظ4-5  
	*
	*ע⣺
	* 1ִPT32x007x_it.cļUART0_Handler
	* 2̻ںշģӲ
	* 3ʹñʱUART1TX(PC7)ܽⷢģġinput2ܽŶ̽ӣⷢģTX_VCCGNDֱDEMOVDDGND̽
  * 4UART0RX(PD6)ܽģġIR_RXܽŶ̽ӣģRX_VCCGNDֱDEMOVDDGND̽
	* 5DEMOλڽӣɷ۲ӦϢ
	* 6ΪСRXDAP¼ֵTX໥ţӦϿDAPӶӵRXţԶϿDAP TXͺն˵RX
	*
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x007x.h"

#define		KEY_PROT		GPIOC
#define		KEY_PIN	    GPIO_Pin_3

#define  IRTX_UART   UART1
/**
* @brief ʱ
* @param 
* @retval 
*/

void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

void KEY_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				    //һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = KEY_PIN;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;		//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;	  //
	GPIO_Init(KEY_PROT, &GPIO_InitStructure);		//ÿ⺯ʼGPIO
		
  GPIO_SetBits(KEY_PROT, KEY_PIN);					//GPIO״̬
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;		//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	  //
	GPIO_Init(GPIOD, &GPIO_InitStructure);		//ÿ⺯ʼGPIO
		
  GPIO_SetBits(GPIOD, GPIO_Pin_6);					//GPIO״̬	
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;							//һNVIC_InitTypeDef͵Ľṹ
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = UART0_IRQn;				//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;				//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;				//жȼ
	NVIC_Init(&NVIC_InitStruct);	
	UART_ITConfig(UART0,UART_IT_RXNEI,ENABLE);
	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 2400;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

void UART_Infrared(void)
{
	UART_InitTypeDef  UART_InitStruct;	
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 2400;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(IRTX_UART, &UART_InitStruct);
	
	//2400
	UART_IrDABaudRateConfig(IRTX_UART,UART_Infrared_BaudRateX3);
	//
	UART_IrDAPolarityConfig(IRTX_UART,DISABLE);
	//50%ռձȵĵź
	UART_IrDADutyCycleConfig(IRTX_UART,0x0);
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_7, AFIO_AF_3,ENABLE);	//PC7 TX1
	
	/*UARTĺⷢ͹*/
	UART_IrDACmd(IRTX_UART,ENABLE);
	UART_Cmd(IRTX_UART,ENABLE);
}
/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

extern u16 data_rx[20];
extern u8 cnt;

u8 IRTX_data[]="ãϢɺ߷";

#define IRTX_DATA_LEN  (sizeof(IRTX_data)-1)
int main (void)
{
	u8 i=0,j=0;
	UART_Driver();
	UART_Infrared();
	KEY_Driver();
	printf("ӭʹPT32x007xϵ\r\n");
	while(1)
  {
		while(cnt)
		{
			UART_SendData(UART0,data_rx[i++]);
			if(i==cnt)
			{
				i=0;
				cnt=0;
			}
		}
		if(GPIO_ReadDataBit(KEY_PROT,KEY_PIN)==0)
		{
			Delay(1000);
			if(GPIO_ReadDataBit(KEY_PROT,KEY_PIN)==0)
			{
				for(j=0;j<IRTX_DATA_LEN;j++)
				{
					UART_SendData(IRTX_UART,IRTX_data[j]);
				}
				Software_Delay();
			}
		}
	}
}
	
 
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
