/******************************************************************************
  * @file    PT32Y003x_it.c
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief    This file provides all interrupt service routine.
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/
  
/* Includes ------------------------------------------------------------------------------------------------*/
#include "PT32x007x_it.h"


/** @defgroup IT
  * @brief IT driver modules
  * @{
  */
  
/* Private typedef -----------------------------------------------------------------------------------------*/
/* Private define ------------------------------------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------------------------------------*/



/**
* @brief NMIжϷ
* @param None
* @retval None
*/
void NMI_Handler(void)
{
}

/**
* @brief HardFaultжϷ
* @param None
* @retval None
*/
void HardFault_Handler(void)
{
  	while (1);
}

/**
* @brief SVCжϷ
* @param None
* @retval None
*/
void SVC_Handler(void)
{
}

/**
* @brief PendSVжϷ
* @param None
* @retval None
*/
void PendSV_Handler(void)
{
}

/**
* @brief SysTickжϷ
* @param None
* @retval None
*/
void SysTick_Handler(void)
{
}

/**
* @brief PLLFAIL
* @param None
* @retval None
*/
void HSEFAIL(void)
{
}

/**
* @brief IMMCжϷ
* @param None
* @retval None
*/
void IMMC_Handler(void)
{
}

/**
* @brief PAжϷ
* @param None
* @retval None
*/
void EXTIA_Handler(void)
{
}

/**
* @brief PBжϷ
* @param None
* @retval None
*/
void EXTIB_Handler(void)
{
}

/**
* @brief PCжϷ
* @param None
* @retval None
*/
void EXTIC_Handler(void)
{
}

/**
* @brief PDжϷ
* @param None
* @retval None
*/
void EXTID_Handler(void)
{
}

/**
* @brief ADCжϷ
* @param None
* @retval None
*/
void ADC_Handler(void)
{
}

/**
* @brief TIMER1жϷ
* @param None
* @retval None
*/
u32 	Isr_capture_Value = 0;
u32 	Isr_capture_Value_2 = 0;
u8		CapIsr_Flag = 0;
extern PWM_ICInitTypeDef	CapPutInit;
void TIM1_Handler(void)
{
	if(PWM_GetFlagStatus(TIM1,PWM_FLAG_IC1F)==SET)			//ȡ־Ƿ
	{
		PWM_ClearFlag(TIM1,PWM_FLAG_IC1F);					//־
		Isr_capture_Value = PWM_GetICxValue(TIM1,PWM_Channel_1);	//ȡֵ
	}
	else if(PWM_GetFlagStatus(TIM1,PWM_FLAG_IC1R)==SET)
	{
		PWM_ClearFlag(TIM1,PWM_FLAG_IC1R);
		Isr_capture_Value_2 = PWM_GetICxValue(TIM1,PWM_Channel_1);
		CapIsr_Flag = 1;
	}	
}

/**
* @brief TIMER2жϷ
* @param None
* @retval None
*/
//͵ƽʱӦΪĸߵƽʱ
u8 Tim_FLAG=0;
void TIM2_Handler(void)
{
	TIM_ClearFlag(TIM2, TIM_FLAG_ARF);	//־
	if(Tim_FLAG>2) Tim_FLAG=0;	
	if(Tim_FLAG==1)
	{
		GPIO_SetBits(GPIOD, GPIO_Pin_4);
	}
	else
	{
		GPIO_ResetBits(GPIOD, GPIO_Pin_4);
	}
		Tim_FLAG++;
}

/**
* @brief TIMER3жϷ
* @param None
* @retval None
*/
void TIM3_Handler(void)
{
}

/**
* @brief TIMER4жϷ
* @param None
* @retval None
*/
void TIM4_Handler(void)
{
}

/**
* @brief PVDжϷ
* @param None
* @retval None
*/
void PVD_Handler(void)
{
}

/**
* @brief I2C0жϷ
* @param None
* @retval None
*/
void I2C0_Handler(void)
{
}


/**
* @brief SPI0жϷ
* @param None
* @retval None
*/
void SPI0_Handler(void)
{
}


/**
* @brief UART0жϷ
* @param None
* @retval None
*/
void UART0_Handler(void)
{
}

/**
* @brief UART1жϷ
* @param None
* @retval None
*/
void UART1_Handler(void)
{	
}


/**
  * @}
  */

