/******************************************************************************
  * @Example IFMC
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   дݣȡͨڴӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *							
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x007x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}
void IFMC_Driver(void)
{
	//õ1Mhz IFMCʱ
	u32 hclk,i,j;
	hclk=RCC_GetClockFreq(RCC_HCLK);
	i=hclk/1000000;
  j = hclk % 1000000;
  if (j>0)
	{
		IFMC_SetPrescaler(i+1);
	}
  else
  {
   IFMC_SetPrescaler(i);  	
  }
}


int main (void)
{
	UART_Driver();
	IFMC_Driver();
	if(IFMC_ReadWord(0x00007000)!=123)//ͨж׵ַʶǷѾд
	{
	  IFMC_ErasePage(0x7000);
    IFMC_ProgramWord(0x00007000,123);//64kb flashд
    IFMC_ProgramWord(0x00007004,456);
    IFMC_ProgramWord(0x00007008,0xAA);
    IFMC_ProgramWord(0x0000700C,0xDD);
 
    printf("0x00007000:%d\r\n",(unsigned int)IFMC_ReadWord(0x00007000));
    printf("0x00007004:%d\r\n",(unsigned int)IFMC_ReadWord(0x00007004));
    printf("0x00007008:%X\r\n",IFMC_ReadByte(0x00007008));
    printf("0x0000700C:%X\r\n",IFMC_ReadByte(0x0000700C));
	}
	else 
		printf ("Flashѳɹд\r\n");
	while(1);
}
	
 
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
