/******************************************************************************
  * @Example PVDInterrupt
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief  ⲿԴ<=3.0ʱԴ͵ѹ¼"PVD"LEDƵ
  *         ֱԴ>=3.03VPVD˳жϣLEDϨ           
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *  ʹø̣
  *  Ҫ蹩J9߽
  *  ʹⲿԴ磬ӷӴ(P1)VOUTGNDⲿԴѹ۲LED
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32x007x.h"

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

void GPIO_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;			
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	
	GPIO_Init(GPIOD, &GPIO_InitStructure);				
		
  GPIO_SetBits(GPIOD, GPIO_Pin_4);
}

/*******************************************************************************
*Function:	PVD_Int_Driver
*Description:	PVDģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void PVD_Int_Driver(void)
{
	RCC_ClearFlag(RCC_FLAG_POR);
	RCC_ClearFlag(RCC_FLAG_PVD);
	RCC_ResetConfig(RCC_ResetEnable_PDRE,DISABLE);
	
	NVIC_EnableIRQ(PVD_IRQn);
	PWR_PVDLevelConfig(PWR_PVDLevel_5);//PVDֵΪ3.0V
	PWR_PVDCmd(ENABLE);				//PVDʹ
}

int main (void)
{
	GPIO_Driver();
	PVD_Int_Driver();
	while(1)
	{
			GPIO_SetBits(GPIOD, GPIO_Pin_4);			//high
	}
}



#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


