  /******************************************************************************
  * @Example DifferenceConversion
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ѡADCͨΪڲģͨѹڲοѹ
	*          INNӲͬĵѹĲֵѹҲͬ
	*          1INN(PD5)VDDյõĲֵѹֵӦΪ CH7-INN ,CH7Ϊɵķѹֵ1/2*VDD<CH7<VDDòֵѹֵΪ
  *          2INN(PD5)GNDյõĲֵѹֵӦΪ CH7-INN ,CH7Ϊɵķѹֵ1/2*VDD<CH7<VDDòֵѹֵΪ
	*          ע⣬ΪUART0 TXINNܸãʱ̽UART0 TXܣͨԣ鿴ֵѹֵ
  ******************************************************************************
  * @attention	Ϊδʹô
  *							
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32x007x.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	ADC_Mode_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʼADCģĹ乤ʽ
*******************************************************************************/
void ADC_Mode_Config(void)
{
	ADC_InitTypeDef  ADC_InitStruct;
	ADC_StructInit(&ADC_InitStruct);
	ADC_InitStruct.ADC_Prescaler = 64;						 
	ADC_InitStruct.ADC_Mode = ADC_Mode_Continuous;						//תģʽ
	ADC_InitStruct.ADC_TriggerSource = ADC_TriggerSource_Software;
	ADC_InitStruct.ADC_TimerTriggerSource=ADC_TimerTriggerSource_TIM1ADC;						
	ADC_InitStruct.ADC_Align = ADC_Align_Left;					//
	ADC_InitStruct.ADC_Channel=ADC_Channel_7;	//ͨ7,PC4
	ADC_InitStruct.ADC_ReferencePositive= ADC_ReferencePositive_VDD;	//ѡVDDAΪ˲οƽ
	ADC_InitStruct.ADC_BGVoltage=ADC_BGVoltage_BG1v0;
	ADC_Init(ADC, &ADC_InitStruct);
}

/*******************************************************************************
*Function:	ADC_GPIO_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʹADCģ
*******************************************************************************/
void ADC_GPIO_Config(void)
{
	GPIO_AnalogRemapConfig(AFIOD, GPIO_Pin_5, ENABLE);		//PD5ΪADCͨ(INN)
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_4, ENABLE);		//PC4ΪADCͨ(CH7)
}

/*******************************************************************************
*Function:	ADC_Driver
*Description:	ADCģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void ADC_Driver(void)
{	
	ADC_Mode_Config();
	ADC_InputNegative(ADC,ADC_InputNegative_INN);
}

s16 Tx_Index[100] = {0};
float volatge = 0;
int main (void)
{
	int i;
	s32 ADC_average=0;
	ADC_Driver();
	ADC_Cmd(ADC, ENABLE);		//ADC蹦
	while(!ADC_GetFlagStatus(ADC, ADC_FLAG_RDY));	//ȴADC
			
	Software_Delay();
	for(i=0;i<100;i++)
	{
		ADC_StartOfConversion(ADC);	//ת
		while(!ADC_GetFlagStatus(ADC, ADC_FLAG_EOC));		//ȴADCת
		Tx_Index[i] = (s16)ADC_GetConversionValue(ADC);	//ȡ
	}
	for(i=0;i<100;i++)
	{
		Tx_Index[i] >>= 3;//봦
		ADC_average+=Tx_Index[i];
	}
	ADC_average/=(float)100;
	volatge=((float)ADC_average)*3.29/4096;//ѹֵΪ PC4ѹ-PD5ѹ
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


