  /******************************************************************************
  * @Example ADC_TIMTrigger
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ʹTIMΪԴÿ1sһADCɼʹôϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *							
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32x007x.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief TIM1ĸ
* @param 
* @retval 
*/
void TIM_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_2,ENABLE);//CH1
  GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_4, AFIO_AF_1,ENABLE);//CH1N
}

/**
* @brief TIM1ʽ
* @param 
* @retval 
*/
void TIM_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef PWM_TimeBaseInitType;
	PWM_OCInitTypeDef OutInit;
	/* ʱѡ */
	PWM_TimeBaseInitType.PWM_InternalClockSource = PWM_InternalClockSource_SYSCLK;
	/* ģʽ --  */
	PWM_TimeBaseInitType.PWM_CenterAlignedMode = PWM_CenterAlignedMode_Disable;
	/* ģʽΪϼ */
	PWM_TimeBaseInitType.PWM_Direction = PWM_Direction_Up;
	/* ƥĴ,ۼMR0+1Ƶʺһ»ж */
	PWM_TimeBaseInitType.PWM_AutoReloadValue = 10000;
	/* CNTʱ = Fcksys/(psc+1)*/
	PWM_TimeBaseInitType.PWM_Prescaler = 48*100-1;
	/* ʼTIM1*/
	PWM_TimeBaseInit(TIM1,&PWM_TimeBaseInitType);
	/* ΪPWMͨΪ1ͨ*/
	OutInit.PWM_Channel =PWM_Channel_1;
	/* ģʽ */	
	OutInit.PWM_OCMode = TIM_OCMode_Toggle;
	/* ͻ */
	OutInit.PWM_OCNOutput = PWM_OCNOutput_Enable;		
	OutInit.PWM_OCOutput = PWM_OCOutput_Enable;  
	/* PWMʱƽ״̬ */
	OutInit.PWM_OCIdleState = PWM_OCIdleState_Low;
	OutInit.PWM_OCNIdleState = PWM_OCNIdleState_High;
	/* PWMռձ P = (PWM_OCValue+1) / (PWM_AutoReloadValue+1)*/	
	OutInit.PWM_OCValue = 5000;
  /* PWMȽ*/	
	OutInit.PWM_OCPolarity = PWM_OCPolarity_High;
  OutInit.PWM_OCNPolarity = PWM_OCNPolarity_Low;
	/* ʼ */
	PWM_OCInit(TIM1, &OutInit);
	/* ʹPWM */
	PWM_Cmd(TIM1,ENABLE);
	
	/*ϼȽƥʱADCɼ*/
	PWM_ADCTrigger(TIM1,PWM_ADCTrigger_OC1UE);
}

void TIM_Driver(void)
{
	TIM_GPIO_Config();
	TIM_Mode_Config();
}

/*******************************************************************************
*Function:	ADC_GPIO_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʹADCģ
*******************************************************************************/
void ADC_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOC,GPIO_Pin_4,AFIO_AF_0,DISABLE);//ָ
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_4, ENABLE);		//PC4ΪADCͨ
}

/*******************************************************************************
*Function:	ADC_Mode_Config
*Description:	ADC
*Input:		뷽ʽ
*Return:		
*Others:
			úʼADCģĹ乤ʽ
*******************************************************************************/
void ADC_Mode_Config(u32 ADC_Align)
{
	ADC_InitTypeDef  ADC_InitStruct;
	ADC_StructInit(&ADC_InitStruct);
	ADC_InitStruct.ADC_Prescaler = 48;						 	//ADCƵ48/48=1 MHz
	ADC_InitStruct.ADC_Mode = ADC_Mode_Single;						//תģʽ
	ADC_InitStruct.ADC_TriggerSource = ADC_TriggerSource_Timer;
	ADC_InitStruct.ADC_TimerTriggerSource=ADC_TimerTriggerSource_TIM1ADC;//ʱԴѡTIM0¼
	ADC_InitStruct.ADC_Align = ADC_Align;					//ѡ뷽ʽ
	ADC_InitStruct.ADC_Channel=ADC_Channel_7;						//ͨ7,PC4
	ADC_InitStruct.ADC_ReferencePositive= ADC_ReferencePositive_VDD;	//ѡVDDAΪ˲οƽ
	ADC_InitStruct.ADC_BGVoltage=ADC_BGVoltage_BG1v2;
	ADC_Init(ADC, &ADC_InitStruct);
}

void ADC_Driver(void)
{
	ADC_GPIO_Config();
	ADC_Mode_Config(ADC_Align_Right);//Ҷ
	ADC_Cmd(ADC, ENABLE);		//ADC蹦
	
}	
s16 Tx_Index = 0;
int main (void)
{
	UART_Driver();
	ADC_Driver();
	TIM_Driver();
	printf("ԴΪTIM1CH1Ҷʽת\r\n");
	while(1)
	{
		while(!ADC_GetFlagStatus(ADC, ADC_FLAG_EOC));	 //ȴADC
		Tx_Index = (s16)(ADC_GetConversionValue(ADC)<<2);	//ȡ
		Tx_Index >>= 3;//Ҷ봦
		printf("ADC Value:%d\r\n",Tx_Index);
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


